﻿import flash.display.BitmapData;
import flash.geom.Matrix;
import flash.geom.Point;
import flash.filters.*;
//
class DrawWallpaper {
	var symbolList:Array;
	var canvas:BitmapData;
	var canvasClip:MovieClip;
	//コンストラクタ
	function DrawWallpaper(symbolList:Array) {
		this.symbolList = symbolList;
		//軌跡を描くキャンバス（透明）を作る
		canvas = new BitmapData(Stage.width, Stage.height, true, 0x000000);
		//キャンバスを貼るクリップを作る
		var depth:Number = _root.getNextHighestDepth();
		canvasClip = _root.createEmptyMovieClip("canvasClip", depth);
		canvasClip.attachBitmap(canvas, 1);
		//10回繰り返す
		for (var i = 1; i<=10; i++) {
			drawing();
		}
	}
	//ドロップシャドウ付きイメージを描く
	function drawing() {
		//ドロップシャドウフィルタを作る
		var filter:DropShadowFilter = new DropShadowFilter();
		filter.alpha = 0.5;
		filter.blurX = filter.blurY=10;
		//
		for (var i = 0; i<symbolList.length; i++) {
			//変換マトリックスを作る
			var mtrx:Matrix = new Matrix();
			//イメージの回転
			var angle:Number = Math.random()*Math.PI/2-Math.PI/4;
			mtrx.rotate(angle);
			//イメージの拡大
			var num:Number = Math.max(0.2, Math.random()*1);
			mtrx.scale(num, num);
			//ランダム座標に平行移動
			var ptx:Number = Math.random()*(Stage.height+100)-50;
			var pty:Number = Math.random()*(Stage.width+100)-50;
			mtrx.translate(ptx, pty);
			//ビットマップイメージを読み込む
			var symbolimage:BitmapData = BitmapData.loadBitmap(symbolList[i]);
			//フィルタをかけた後のrectサイズを調べる
			var stampRect = symbolimage.generateFilterRect(symbolimage.rectangle, filter);
			var stampBitmap = new BitmapData(stampRect.width, stampRect.height);
			//symbolimageにフィルタを適用してstampBitmapに複製する
			stampBitmap.applyFilter(symbolimage, stampRect, new Point(0, 0), filter);
			//stampBitmapのイメージを描く
			canvas.draw(stampBitmap, mtrx);
		}
	}
}
